<template>
    <section class="container content" id="app">
        <h1 class="h1 has-text-centered">
            {{ $t('Tiny Tiny RSS pillar generator', {foo: 'bar'}) }}
        </h1>
        <div class="field is-horizontal">
            <div class="field-label is-normal">
                <label for="lang" class="label">
                    {{ $t('Language') }}
                </label>
            </div>
            <div class="field-body">
                <div class="select">
                    <select id="lang" v-model="$i18n.i18next.language" v-on:change="changeLang">
                        <option v-for="lang in filteredLangs" v-bind:key="lang" :value="lang">{{ nativeName(lang) }}</option>
                    </select>
                </div>
            </div>
        </div>
        <Form/>
        <footer class="has-text-centered is-size-7">
            <span v-html="$t('Created by {{- opentag}}Luc Didry{{- endtag}}', { opentag: fiatTuxUrl })"></span>
            —
            <a href="https://framagit.org/fiat-tux/salt/ttrss" target="_blank" rel="noreferrer">{{ $t('Source') }}</a>
        </footer>
    </section>
</template>

<script>
import Form from './components/Form.vue'
let iso_639_1 = require('iso-639').iso_639_1

export default {
    name: 'app',
    components: {
        Form
    },
    data() {
        return {
            fiatTuxUrl: '<a href="https://fiat-tux.fr" target="_blank" rel="noreferrer">',
        }
    },
    methods: {
        nativeName: function(code) {
            return this.capitalizeFirstLetter(iso_639_1[code].nativeName);
        },
        changeLang: function(event) {
            this.$i18n.i18next.changeLanguage(event.target.value);
        },
        capitalizeFirstLetter: function(string) {
            return string.charAt(0).toUpperCase() + string.slice(1);
        }
    },
    computed: {
        filteredLangs: function() {
            let langs = this.$i18n.i18next.options.whitelist
            let index = langs.indexOf('cimode')
            if (index === -1)
                return langs
            langs.splice(index, 1)
            return langs
        }
    }
}
</script>

<style lang="sass">
@import '../node_modules/bulma/sass/utilities/_all.sass'
@import '../node_modules/bulma/sass/base/_all.sass'
@import '../node_modules/bulma/sass/layout/section.sass'
@import '../node_modules/bulma/sass/grid/columns.sass'
@import '../node_modules/bulma/sass/elements/content.sass'
@import '../node_modules/bulma/sass/elements/container.sass'
@import '../node_modules/bulma/sass/elements/button.sass'
@import '../node_modules/bulma/sass/elements/tag.sass'
@import '../node_modules/bulma/sass/elements/form.sass'
@import '../node_modules/bulma-extensions/bulma-accordion/dist/css/bulma-accordion.sass'

.container
    margin-top:   20px
    margin-left:  auto
    margin-right: auto
    max-width:    960px
footer
    margin-top:   10px
</style>
